=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpFileClient
  class AcsFileApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a file alternate content source
    # Alternate Content Source ViewSet for File  ACS support is provided as a tech preview in pulp_file.
    # @param file_file_alternate_content_source [FileFileAlternateContentSource] 
    # @param [Hash] opts the optional parameters
    # @return [FileFileAlternateContentSourceResponse]
    def create(file_file_alternate_content_source, opts = {})
      data, _status_code, _headers = create_with_http_info(file_file_alternate_content_source, opts)
      data
    end

    # Create a file alternate content source
    # Alternate Content Source ViewSet for File  ACS support is provided as a tech preview in pulp_file.
    # @param file_file_alternate_content_source [FileFileAlternateContentSource] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(FileFileAlternateContentSourceResponse, Integer, Hash)>] FileFileAlternateContentSourceResponse data, response status code and response headers
    def create_with_http_info(file_file_alternate_content_source, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AcsFileApi.create ...'
      end
      # verify the required parameter 'file_file_alternate_content_source' is set
      if @api_client.config.client_side_validation && file_file_alternate_content_source.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_alternate_content_source' when calling AcsFileApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/acs/file/file/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(file_file_alternate_content_source) 

      # return_type
      return_type = opts[:return_type] || 'FileFileAlternateContentSourceResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AcsFileApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a file alternate content source
    # Alternate Content Source ViewSet for File  ACS support is provided as a tech preview in pulp_file.
    # @param file_file_alternate_content_source_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete(file_file_alternate_content_source_href, opts = {})
      delete_with_http_info(file_file_alternate_content_source_href, opts)
      nil
    end

    # Delete a file alternate content source
    # Alternate Content Source ViewSet for File  ACS support is provided as a tech preview in pulp_file.
    # @param file_file_alternate_content_source_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def delete_with_http_info(file_file_alternate_content_source_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AcsFileApi.delete ...'
      end
      # verify the required parameter 'file_file_alternate_content_source_href' is set
      if @api_client.config.client_side_validation && file_file_alternate_content_source_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_alternate_content_source_href' when calling AcsFileApi.delete"
      end
      # resource path
      local_var_path = '{file_file_alternate_content_source_href}'.sub('{' + 'file_file_alternate_content_source_href' + '}', CGI.escape(file_file_alternate_content_source_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AcsFileApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List file alternate content sources
    # Alternate Content Source ViewSet for File  ACS support is provided as a tech preview in pulp_file.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name 
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedfileFileAlternateContentSourceResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List file alternate content sources
    # Alternate Content Source ViewSet for File  ACS support is provided as a tech preview in pulp_file.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name 
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedfileFileAlternateContentSourceResponseList, Integer, Hash)>] PaginatedfileFileAlternateContentSourceResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AcsFileApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/acs/file/file/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__contains'] = opts[:'name__contains'] if !opts[:'name__contains'].nil?
      query_params[:'name__icontains'] = opts[:'name__icontains'] if !opts[:'name__icontains'].nil?
      query_params[:'name__in'] = @api_client.build_collection_param(opts[:'name__in'], :csv) if !opts[:'name__in'].nil?
      query_params[:'name__startswith'] = opts[:'name__startswith'] if !opts[:'name__startswith'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedfileFileAlternateContentSourceResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AcsFileApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a file alternate content source
    # Alternate Content Source ViewSet for File  ACS support is provided as a tech preview in pulp_file.
    # @param file_file_alternate_content_source_href [String] 
    # @param patchedfile_file_alternate_content_source [PatchedfileFileAlternateContentSource] 
    # @param [Hash] opts the optional parameters
    # @return [FileFileAlternateContentSourceResponse]
    def partial_update(file_file_alternate_content_source_href, patchedfile_file_alternate_content_source, opts = {})
      data, _status_code, _headers = partial_update_with_http_info(file_file_alternate_content_source_href, patchedfile_file_alternate_content_source, opts)
      data
    end

    # Update a file alternate content source
    # Alternate Content Source ViewSet for File  ACS support is provided as a tech preview in pulp_file.
    # @param file_file_alternate_content_source_href [String] 
    # @param patchedfile_file_alternate_content_source [PatchedfileFileAlternateContentSource] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(FileFileAlternateContentSourceResponse, Integer, Hash)>] FileFileAlternateContentSourceResponse data, response status code and response headers
    def partial_update_with_http_info(file_file_alternate_content_source_href, patchedfile_file_alternate_content_source, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AcsFileApi.partial_update ...'
      end
      # verify the required parameter 'file_file_alternate_content_source_href' is set
      if @api_client.config.client_side_validation && file_file_alternate_content_source_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_alternate_content_source_href' when calling AcsFileApi.partial_update"
      end
      # verify the required parameter 'patchedfile_file_alternate_content_source' is set
      if @api_client.config.client_side_validation && patchedfile_file_alternate_content_source.nil?
        fail ArgumentError, "Missing the required parameter 'patchedfile_file_alternate_content_source' when calling AcsFileApi.partial_update"
      end
      # resource path
      local_var_path = '{file_file_alternate_content_source_href}'.sub('{' + 'file_file_alternate_content_source_href' + '}', CGI.escape(file_file_alternate_content_source_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(patchedfile_file_alternate_content_source) 

      # return_type
      return_type = opts[:return_type] || 'FileFileAlternateContentSourceResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AcsFileApi#partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a file alternate content source
    # Alternate Content Source ViewSet for File  ACS support is provided as a tech preview in pulp_file.
    # @param file_file_alternate_content_source_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [FileFileAlternateContentSourceResponse]
    def read(file_file_alternate_content_source_href, opts = {})
      data, _status_code, _headers = read_with_http_info(file_file_alternate_content_source_href, opts)
      data
    end

    # Inspect a file alternate content source
    # Alternate Content Source ViewSet for File  ACS support is provided as a tech preview in pulp_file.
    # @param file_file_alternate_content_source_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(FileFileAlternateContentSourceResponse, Integer, Hash)>] FileFileAlternateContentSourceResponse data, response status code and response headers
    def read_with_http_info(file_file_alternate_content_source_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AcsFileApi.read ...'
      end
      # verify the required parameter 'file_file_alternate_content_source_href' is set
      if @api_client.config.client_side_validation && file_file_alternate_content_source_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_alternate_content_source_href' when calling AcsFileApi.read"
      end
      # resource path
      local_var_path = '{file_file_alternate_content_source_href}'.sub('{' + 'file_file_alternate_content_source_href' + '}', CGI.escape(file_file_alternate_content_source_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'FileFileAlternateContentSourceResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AcsFileApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Alternate Content Source ViewSet for File  ACS support is provided as a tech preview in pulp_file.
    # @param file_file_alternate_content_source_href [String] 
    # @param file_file_alternate_content_source [FileFileAlternateContentSource] 
    # @param [Hash] opts the optional parameters
    # @return [FileFileAlternateContentSourceResponse]
    def refresh(file_file_alternate_content_source_href, file_file_alternate_content_source, opts = {})
      data, _status_code, _headers = refresh_with_http_info(file_file_alternate_content_source_href, file_file_alternate_content_source, opts)
      data
    end

    # Alternate Content Source ViewSet for File  ACS support is provided as a tech preview in pulp_file.
    # @param file_file_alternate_content_source_href [String] 
    # @param file_file_alternate_content_source [FileFileAlternateContentSource] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(FileFileAlternateContentSourceResponse, Integer, Hash)>] FileFileAlternateContentSourceResponse data, response status code and response headers
    def refresh_with_http_info(file_file_alternate_content_source_href, file_file_alternate_content_source, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AcsFileApi.refresh ...'
      end
      # verify the required parameter 'file_file_alternate_content_source_href' is set
      if @api_client.config.client_side_validation && file_file_alternate_content_source_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_alternate_content_source_href' when calling AcsFileApi.refresh"
      end
      # verify the required parameter 'file_file_alternate_content_source' is set
      if @api_client.config.client_side_validation && file_file_alternate_content_source.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_alternate_content_source' when calling AcsFileApi.refresh"
      end
      # resource path
      local_var_path = '{file_file_alternate_content_source_href}refresh/'.sub('{' + 'file_file_alternate_content_source_href' + '}', CGI.escape(file_file_alternate_content_source_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(file_file_alternate_content_source) 

      # return_type
      return_type = opts[:return_type] || 'FileFileAlternateContentSourceResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AcsFileApi#refresh\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a file alternate content source
    # Alternate Content Source ViewSet for File  ACS support is provided as a tech preview in pulp_file.
    # @param file_file_alternate_content_source_href [String] 
    # @param file_file_alternate_content_source [FileFileAlternateContentSource] 
    # @param [Hash] opts the optional parameters
    # @return [FileFileAlternateContentSourceResponse]
    def update(file_file_alternate_content_source_href, file_file_alternate_content_source, opts = {})
      data, _status_code, _headers = update_with_http_info(file_file_alternate_content_source_href, file_file_alternate_content_source, opts)
      data
    end

    # Update a file alternate content source
    # Alternate Content Source ViewSet for File  ACS support is provided as a tech preview in pulp_file.
    # @param file_file_alternate_content_source_href [String] 
    # @param file_file_alternate_content_source [FileFileAlternateContentSource] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(FileFileAlternateContentSourceResponse, Integer, Hash)>] FileFileAlternateContentSourceResponse data, response status code and response headers
    def update_with_http_info(file_file_alternate_content_source_href, file_file_alternate_content_source, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AcsFileApi.update ...'
      end
      # verify the required parameter 'file_file_alternate_content_source_href' is set
      if @api_client.config.client_side_validation && file_file_alternate_content_source_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_alternate_content_source_href' when calling AcsFileApi.update"
      end
      # verify the required parameter 'file_file_alternate_content_source' is set
      if @api_client.config.client_side_validation && file_file_alternate_content_source.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_alternate_content_source' when calling AcsFileApi.update"
      end
      # resource path
      local_var_path = '{file_file_alternate_content_source_href}'.sub('{' + 'file_file_alternate_content_source_href' + '}', CGI.escape(file_file_alternate_content_source_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(file_file_alternate_content_source) 

      # return_type
      return_type = opts[:return_type] || 'FileFileAlternateContentSourceResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AcsFileApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
