=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpFileClient
  class RepositoriesFileApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a file repository
    #  FileRepository represents a single file repository, to which content can be synced, added, or removed.
    # @param file_file_repository [FileFileRepository] 
    # @param [Hash] opts the optional parameters
    # @return [FileFileRepositoryResponse]
    def create(file_file_repository, opts = {})
      data, _status_code, _headers = create_with_http_info(file_file_repository, opts)
      data
    end

    # Create a file repository
    #  FileRepository represents a single file repository, to which content can be synced, added, or removed.
    # @param file_file_repository [FileFileRepository] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(FileFileRepositoryResponse, Integer, Hash)>] FileFileRepositoryResponse data, response status code and response headers
    def create_with_http_info(file_file_repository, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesFileApi.create ...'
      end
      # verify the required parameter 'file_file_repository' is set
      if @api_client.config.client_side_validation && file_file_repository.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_repository' when calling RepositoriesFileApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/repositories/file/file/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(file_file_repository) 

      # return_type
      return_type = opts[:return_type] || 'FileFileRepositoryResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesFileApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a file repository
    # Trigger an asynchronous delete task
    # @param file_file_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def delete(file_file_repository_href, opts = {})
      data, _status_code, _headers = delete_with_http_info(file_file_repository_href, opts)
      data
    end

    # Delete a file repository
    # Trigger an asynchronous delete task
    # @param file_file_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def delete_with_http_info(file_file_repository_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesFileApi.delete ...'
      end
      # verify the required parameter 'file_file_repository_href' is set
      if @api_client.config.client_side_validation && file_file_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_repository_href' when calling RepositoriesFileApi.delete"
      end
      # resource path
      local_var_path = '{file_file_repository_href}'.sub('{' + 'file_file_repository_href' + '}', CGI.escape(file_file_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesFileApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List file repositorys
    #  FileRepository represents a single file repository, to which content can be synced, added, or removed.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name 
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :pulp_label_select Filter labels by search string
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedfileFileRepositoryResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List file repositorys
    #  FileRepository represents a single file repository, to which content can be synced, added, or removed.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name 
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :pulp_label_select Filter labels by search string
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedfileFileRepositoryResponseList, Integer, Hash)>] PaginatedfileFileRepositoryResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesFileApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/repositories/file/file/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__contains'] = opts[:'name__contains'] if !opts[:'name__contains'].nil?
      query_params[:'name__icontains'] = opts[:'name__icontains'] if !opts[:'name__icontains'].nil?
      query_params[:'name__in'] = @api_client.build_collection_param(opts[:'name__in'], :csv) if !opts[:'name__in'].nil?
      query_params[:'name__startswith'] = opts[:'name__startswith'] if !opts[:'name__startswith'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'pulp_label_select'] = opts[:'pulp_label_select'] if !opts[:'pulp_label_select'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedfileFileRepositoryResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesFileApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Modify Repository Content
    # Trigger an asynchronous task to create a new repository version.
    # @param file_file_repository_href [String] 
    # @param repository_add_remove_content [RepositoryAddRemoveContent] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def modify(file_file_repository_href, repository_add_remove_content, opts = {})
      data, _status_code, _headers = modify_with_http_info(file_file_repository_href, repository_add_remove_content, opts)
      data
    end

    # Modify Repository Content
    # Trigger an asynchronous task to create a new repository version.
    # @param file_file_repository_href [String] 
    # @param repository_add_remove_content [RepositoryAddRemoveContent] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def modify_with_http_info(file_file_repository_href, repository_add_remove_content, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesFileApi.modify ...'
      end
      # verify the required parameter 'file_file_repository_href' is set
      if @api_client.config.client_side_validation && file_file_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_repository_href' when calling RepositoriesFileApi.modify"
      end
      # verify the required parameter 'repository_add_remove_content' is set
      if @api_client.config.client_side_validation && repository_add_remove_content.nil?
        fail ArgumentError, "Missing the required parameter 'repository_add_remove_content' when calling RepositoriesFileApi.modify"
      end
      # resource path
      local_var_path = '{file_file_repository_href}modify/'.sub('{' + 'file_file_repository_href' + '}', CGI.escape(file_file_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(repository_add_remove_content) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesFileApi#modify\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a file repository
    # Trigger an asynchronous partial update task
    # @param file_file_repository_href [String] 
    # @param patchedfile_file_repository [PatchedfileFileRepository] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def partial_update(file_file_repository_href, patchedfile_file_repository, opts = {})
      data, _status_code, _headers = partial_update_with_http_info(file_file_repository_href, patchedfile_file_repository, opts)
      data
    end

    # Update a file repository
    # Trigger an asynchronous partial update task
    # @param file_file_repository_href [String] 
    # @param patchedfile_file_repository [PatchedfileFileRepository] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def partial_update_with_http_info(file_file_repository_href, patchedfile_file_repository, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesFileApi.partial_update ...'
      end
      # verify the required parameter 'file_file_repository_href' is set
      if @api_client.config.client_side_validation && file_file_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_repository_href' when calling RepositoriesFileApi.partial_update"
      end
      # verify the required parameter 'patchedfile_file_repository' is set
      if @api_client.config.client_side_validation && patchedfile_file_repository.nil?
        fail ArgumentError, "Missing the required parameter 'patchedfile_file_repository' when calling RepositoriesFileApi.partial_update"
      end
      # resource path
      local_var_path = '{file_file_repository_href}'.sub('{' + 'file_file_repository_href' + '}', CGI.escape(file_file_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(patchedfile_file_repository) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesFileApi#partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a file repository
    #  FileRepository represents a single file repository, to which content can be synced, added, or removed.
    # @param file_file_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [FileFileRepositoryResponse]
    def read(file_file_repository_href, opts = {})
      data, _status_code, _headers = read_with_http_info(file_file_repository_href, opts)
      data
    end

    # Inspect a file repository
    #  FileRepository represents a single file repository, to which content can be synced, added, or removed.
    # @param file_file_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(FileFileRepositoryResponse, Integer, Hash)>] FileFileRepositoryResponse data, response status code and response headers
    def read_with_http_info(file_file_repository_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesFileApi.read ...'
      end
      # verify the required parameter 'file_file_repository_href' is set
      if @api_client.config.client_side_validation && file_file_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_repository_href' when calling RepositoriesFileApi.read"
      end
      # resource path
      local_var_path = '{file_file_repository_href}'.sub('{' + 'file_file_repository_href' + '}', CGI.escape(file_file_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'FileFileRepositoryResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesFileApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Trigger an asynchronous task to sync file content.
    # @param file_file_repository_href [String] 
    # @param repository_sync_url [RepositorySyncURL] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def sync(file_file_repository_href, repository_sync_url, opts = {})
      data, _status_code, _headers = sync_with_http_info(file_file_repository_href, repository_sync_url, opts)
      data
    end

    # Trigger an asynchronous task to sync file content.
    # @param file_file_repository_href [String] 
    # @param repository_sync_url [RepositorySyncURL] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def sync_with_http_info(file_file_repository_href, repository_sync_url, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesFileApi.sync ...'
      end
      # verify the required parameter 'file_file_repository_href' is set
      if @api_client.config.client_side_validation && file_file_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_repository_href' when calling RepositoriesFileApi.sync"
      end
      # verify the required parameter 'repository_sync_url' is set
      if @api_client.config.client_side_validation && repository_sync_url.nil?
        fail ArgumentError, "Missing the required parameter 'repository_sync_url' when calling RepositoriesFileApi.sync"
      end
      # resource path
      local_var_path = '{file_file_repository_href}sync/'.sub('{' + 'file_file_repository_href' + '}', CGI.escape(file_file_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(repository_sync_url) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesFileApi#sync\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a file repository
    # Trigger an asynchronous update task
    # @param file_file_repository_href [String] 
    # @param file_file_repository [FileFileRepository] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def update(file_file_repository_href, file_file_repository, opts = {})
      data, _status_code, _headers = update_with_http_info(file_file_repository_href, file_file_repository, opts)
      data
    end

    # Update a file repository
    # Trigger an asynchronous update task
    # @param file_file_repository_href [String] 
    # @param file_file_repository [FileFileRepository] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def update_with_http_info(file_file_repository_href, file_file_repository, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesFileApi.update ...'
      end
      # verify the required parameter 'file_file_repository_href' is set
      if @api_client.config.client_side_validation && file_file_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_repository_href' when calling RepositoriesFileApi.update"
      end
      # verify the required parameter 'file_file_repository' is set
      if @api_client.config.client_side_validation && file_file_repository.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_repository' when calling RepositoriesFileApi.update"
      end
      # resource path
      local_var_path = '{file_file_repository_href}'.sub('{' + 'file_file_repository_href' + '}', CGI.escape(file_file_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(file_file_repository) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesFileApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
